/*******************************************************************************
Copyright © 2024 Sebastian Roith

Licensed under CC BY 4.0. To view a copy of this license, visit http://creativecommons.org/licenses/by/4.0/
*******************************************************************************/

(function(window) {

const TABLES = [
    { name: "AGENT", primary: ["id"], table: [
        ["id", "nachname", "vorname", "geburtsjahr", "taetigkeit"],
        [7, "Bond", "James", 1953, "Bürokram"],
        [6, "Powers", "Austin", 1997, "Bürokram"],
        [11, "Peel", "Emma", 1960, "Kampftraining"],
        [8, "Bristow", "Sydney", 1975, "Spionage"],
        [86, "Smart", "Maxwell", 1965, "Observation"]
    ] },
    { name: "BOESEWICHT", primary: ["id"], table: [
        ["id", "nachname", "vorname", "verbrechen"],
        [1, "Blofeld", "Ernst", "Weltherrschaftsphantasien"],
        [2, "Moriaty", "James", "vielfältig"],
        [3, "de Vil", "Cruella", "Tierschutzvergehen"],
        [4, "Riddle", "Tom", "schwarze Magie"],
        [5, "Hook", "James", "Mordversuche"],
        [6, "Dracula", "Vlad", "Vampirismus"]
    ] }
];

const LEVELS = [
    {
        task: 'Verändere folgende Abfrage so, dass die Ergebnistabelle quasi identisch mit der Datenbanktabelle <em>BOESEWICHT</em> ist (also <em>alle</em> Attribute und Datensätze in <em>derselben Reihenfolge</em>).',
        code: 'SELECT vorname, nachname FROM AGENT',
        tables: TABLES,
        locked: true,
        checkCode: [
            { type: "keyword", value: "where", max: 0, fine: 0, msg: "In dieser Aufgabe ist „WHERE“ nicht erlaubt…" },
            { type: "keyword", value: "order", max: 0, fine: 0, msg: "In dieser Aufgabe ist „ORDER BY“ nicht erlaubt…" },
            { type: "keyword", value: "select", max: 1, fine: 0, msg: "Verwende bei dieser Abfrage das Schlüsselwort „SELECT“ nur einmal!" }
        ],
        checkTermination: [
            { type: "attributeCount", value: 4, fine: 1, msg: "In der Ergebnistabelle muss es exakt vier Attribute geben" },
            { type: "attributeName", index: 0, value: "id", fine: 1, msg: "Das erste Attribut muss „id“ sein" },
            { type: "attributeName", index: 1, value: "nachname", fine: 1, msg: "Das zwei Attribut muss „nachname“ sein" },
            { type: "attributeName", index: 2, value: "vorname", fine: 1, msg: "Das zwei Attribut muss „vorname“ sein" },
            { type: "attributeName", index: 3, value: "verbrechen", fine: 1, msg: "Das zwei Attribut muss „verbrechen“ sein" },
            { type: "sameResult", value: "SELECT * FROM BOESEWICHT", fine: 1 },
            { type: "accept", unlock: true }
        ]
    },
    {
        task: "Probiere nun die folgende Abfrage unverändert aus und beschreibe dann, was dir auffällt.",
        code: 'SELECT * FROM BOESEWICHT',
        tables: TABLES,
        readonly: true,
        locked: true,
        checkCode: [],
        checkTermination: [
            { type: "accept", unlock: true }
        ],
        questionWrongFine: 1,
        question: {
            html: "Was sind naheliegende Vermutungen?",
            choices: [
                { html: "<code>*</code> steht für alle Attribute der nach <code>FROM</code> angegebenen Tabelle", correct: true },
                { html: "<code>*</code> steht für alle Attribute aller Tabellen" },
                { html: "<code>*</code> steht für <em>ein beliebiges</em> Attribut" },
                { html: "<code>*</code> steht für den Primärschlüssel" },
                { html: "Bei <code>*</code> ist die Reihenfolge der Attribute durch das Tabellenschema vorgegeben", correct: true },
                { html: "Bei <code>*</code> ist die Reihenfolge der Attribute zufällig" }
            ]
        }
    },
    {
        task: 'Verstanden, was <code>*</code> bedeutet? Wenn ja, kannst du diese Abfrage deutlich kürzer schreiben. Mache das und probiere dann erst die Abfrage aus.',
        code: 'SELECT id, nachname, vorname, geburtsjahr, taetigkeit FROM AGENT',
        tables: TABLES,
        readonly: false,
        locked: true,
        checkCode: [
            { type: "keyword", value: "where", max: 0, fine: 0, msg: "In dieser Aufgabe ist „WHERE“ nicht erlaubt…" },
            { type: "keyword", value: "order", max: 0, fine: 0, msg: "In dieser Aufgabe ist „ORDER BY“ nicht erlaubt…" },
            { type: "keyword", value: "select", max: 1, fine: 0, msg: "Verwende bei dieser Abfrage das Schlüsselwort „SELECT“ nur einmal!" }
        ],
        checkTermination: [
            { type: "compareQuery", value: "*", noNormalize: true, substring: true, msg: "Verwende den neu gelernten Bestandteil: *" },
            { type: "sameResult", value: "SELECT * FROM AGENT", fine: 1, msg: "Deine Ergebnistabelle ist falsch. Klicke oben auf die Levelnummer, um erneut die ursprüngliche Abfrage zu sehen" },
            { type: "compareQuery", value: "SELECT * FROM AGENT" },
            { type: "accept", unlock: true }
        ]
    },
    {
        task: '<p>Probiere diese Abfrage noch nicht aus, sondern stelle nur eine Vermutung auf, was sie bewirkt!</p><p>Tipp: <code>*</code> steht <em>nicht</em> nur für die fehlenden Attribute…</p>',
        code: 'SELECT nachname, *, taetigkeit  FROM AGENT',
        tables: TABLES,
        readonly: true,
        locked: false,
        checkCode: [
            { type: "accept", accept: false, fine: 1, msg: "Du sollst die Abfrage noch nicht ausprobieren!" }
        ],
        checkTermination: [],
        questionWrongFine: 1,
        question: {
            html: "Was gilt für die Ergebnistabelle?",
            choices: [
                { html: "Die Ergebnistabelle enthält ", unit: " Attribute.", correct: true, "type": "number", min: 0, "accept": 7, response: "Das erste Attribut ist „nachname“, das letzte „taetigkeit“. Das Sternchen steht für alle, also fünf weitere Attribute. Ergibt insgesamt 1 + 5 + 1 = 7 Attribute." },
                { html: "In der Ergebnistabelle steht ein und dasselbe Attribut mehrfach.", response: "„nachname“ und „taetigkeit“ stehen je doppelt in der Ergebnistabelle: Einmal, weil sie explizit erwähnt sind, einmal wegen dem Sternchen.", correct: true },
                { html: "<code>*</code> steht hier nur für die fehlenden drei Attribute.", response: "Das wäre zwar eine sinnvolle Vermutung, stimmt aber nicht, wie dir der Tipp verrät." }
            ]
        }
    },
    {
        task: 'Probiere diese Abfrage nun unverändert aus.',
        code: 'SELECT nachname, *, taetigkeit  FROM AGENT',
        tables: TABLES,
        readonly: true,
        locked: true,
        checkCode: [],
        checkTermination: [
            { type: 'accept', unlock: true }
        ]
    },
    {
        task: 'Auch bei dieser verrückten Abfrage kommen Attribute mehrfach vor. Schreibe sie kürzer, ohne die Ergebnistabelle zu verändern.',
        code: 'SELECT nachname, vorname, id, nachname, vorname, verbrechen, id, nachname, vorname, verbrechen \nFROM BOESEWICHT',
        keepCode: false,
        tables: TABLES,
        readonly: false,
        locked: true,
        checkCode: [
            { type: "keyword", value: "where", max: 0, fine: 0, msg: "In dieser Aufgabe ist „WHERE“ nicht erlaubt…" },
            { type: "keyword", value: "order", max: 0, fine: 0, msg: "In dieser Aufgabe ist „ORDER BY“ nicht erlaubt…" },
            { type: "keyword", value: "select", max: 1, fine: 0, msg: "Verwende bei dieser Abfrage das Schlüsselwort „SELECT“ nur einmal!" }
        ],
        checkTermination: [
            { type: "sameResult", value: "SELECT nachname, vorname, id, nachname, vorname, verbrechen, id, nachname, vorname, verbrechen FROM BOESEWICHT", fine: 1, msg: "Deine Ergebnistabelle weicht von der ursprünglichen Ergebnistabelle ab. Klicke ganz oben auf die Levelnummer, um wieder die ursprüngliche Abfrage zu haben" },
            { type: "compareQuery", value: "*", noNormalize: true, substring: true, msg: "Verwende den neu gelernten Bestandteil: *" },
            { type: "compareQuery", value: "SELECT nachname, vorname, *, * FROM BOESEWICHT", msg: "Es geht noch kürzer…" },
            { type: "accept", unlock: true }
        ],
        questionWrongFine: 1,
        question: {
            html: "Was hast du über SQL-Abfragen gelernt? Kreuze nur die zutreffenden Aussagen an und ergänze die fehlenden Eintragungen.",
            choices: [
                { html: "Das Zeichen ", unit: " steht für alle Attribute der nach <code>FROM</code> genannten Tabelle.", correct: true, maxlength: 1, size: 1, type: "text", accept: "*" },
                { html: "Das Zeichen ", unit: " steht für alle <em>nicht anderweitig aufgeführten</em> Attribute der nach <code>FROM</code> genannten Tabelle.", maxlength: 1, size: 1, type: "text" },
                { html: "Eine Ergebnistabelle kann dasselbe Attribut <em>mehrfach</em> enthalten.", correct: true },
                { html: "In einer Ergebnistabelle steht jedes Attribut immer <em>höchstens einmal</em>." }
            ]
        }
    }
];

window.sqlCodingTask = {
    levels: LEVELS
};
})(window);
